//+------------------------------------------------------------------+
//|                                                       Series.mqh |
//|           Copyright 2016, Vasiliy Sokolov, St-Petersburg, Russia |
//|                                https://www.mql5.com/ru/users/c-4 |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, Vasiliy Sokolov."
#property link      "https://www.mql5.com/ru/users/c-4"
//+------------------------------------------------------------------+
//|       .     |
//+------------------------------------------------------------------+
class CBaseRates
  {
protected:
   string            m_symbol;
   ENUM_TIMEFRAMES   m_timeframe;
                     CBaseRates(void);
public:
   string            Symbol(void);
   ENUM_TIMEFRAMES   Timeframe(void);
   void              Symbol(string symbol);
   void              Timeframe(ENUM_TIMEFRAMES tf);
   int               Total(void);
  };
//+------------------------------------------------------------------+
//|   .                                        |
//+------------------------------------------------------------------+
CBaseRates::CBaseRates(void)
  {
  }
//+------------------------------------------------------------------+
//|   .                                         |
//+------------------------------------------------------------------+
string CBaseRates::Symbol(void)
  {
   return m_symbol;
  }
//+------------------------------------------------------------------+
//|   .                                      |
//+------------------------------------------------------------------+
void CBaseRates::Symbol(string symbol)
  {
   m_symbol=symbol;
  }
//+------------------------------------------------------------------+
//|   .                                |
//+------------------------------------------------------------------+
ENUM_TIMEFRAMES CBaseRates::Timeframe(void)
  {
   return m_timeframe;
  }
//+------------------------------------------------------------------+
//|   .                             |
//+------------------------------------------------------------------+
void CBaseRates::Timeframe(ENUM_TIMEFRAMES tf)
  {
   m_timeframe=tf;
  }
//+------------------------------------------------------------------+
//|    .                           |
//+------------------------------------------------------------------+
int CBaseRates::Total(void)
  {
   return Bars(m_symbol, m_timeframe);
  }
//+------------------------------------------------------------------+
//|        . |
//+------------------------------------------------------------------+
class COpen : public CBaseRates
  {
public:
   double operator[](int index)
     {
      double value[];
      if(CopyOpen(m_symbol, m_timeframe, index, 1, value) == 0)return 0.0;
      return value[0];
     }
  };
//+------------------------------------------------------------------+
//|      .                    |
//+------------------------------------------------------------------+
class CHigh : public CBaseRates
  {
public:
   double operator[](int index)
     {
      double value[];
      if(CopyHigh(m_symbol, m_timeframe, index, 1, value) == 0)return 0.0;
      return value[0];
     }
  };
//+------------------------------------------------------------------+
//|      .                     |
//+------------------------------------------------------------------+
class CLow : public CBaseRates
  {
public:
   double operator[](int index)
     {
      double value[];
      if(CopyLow(m_symbol, m_timeframe, index, 1, value) == 0)return 0.0;
      return value[0];
     }
  };
//+------------------------------------------------------------------+
//|      .                        |
//+------------------------------------------------------------------+
class CClose : public CBaseRates
  {
public:
   double operator[](int index)
     {
      double value[];
      if(CopyClose(m_symbol, m_timeframe, index, 1, value) == 0)return 0.0;
      return value[0];
     }
  };
//+------------------------------------------------------------------+
//|      .                      |
//+------------------------------------------------------------------+
class CVolume : public CBaseRates
  {
public:
   long operator[](int index)
     {
      long value[];
      if(CopyRealVolume(m_symbol, m_timeframe, index, 1, value) == 0)return 0;
      return value[0];
     }
  };
//+------------------------------------------------------------------+
//|      .                       |
//+------------------------------------------------------------------+
class CTickVolume : public CBaseRates
  {
public:
   long operator[](int index)
     {
      long value[];
      if(CopyTickVolume(m_symbol, m_timeframe, index, 1, value) == 0)return 0;
      return value[0];
     }
  };
//+------------------------------------------------------------------+
//|     .                                 |
//+------------------------------------------------------------------+
class CTime : public CBaseRates
  {
public:
   datetime operator[](int index)
     {
      datetime value[];
      if(CopyTime(m_symbol, m_timeframe, index, 1, value) == 0)return 0;
      return value[0];
     }
  };
//+------------------------------------------------------------------+
