//+------------------------------------------------------------------+
//|                                             TradeEnvironment.mqh |
//|           Copyright 2016, Vasiliy Sokolov, St-Petersburg, Russia |
//|                                https://www.mql5.com/ru/users/c-4 |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, Vasiliy Sokolov."
#property link      "https://www.mql5.com/ru/users/c-4"
#include <Dictionary.mqh>
//+------------------------------------------------------------------+
//|  .                                                |
//+------------------------------------------------------------------+
/*class CPendingOrder : public CObject
  {
public:
                     CPendingOrder(void) : Price(0.0){;}
   double            Price;        //  
  };*/
//+------------------------------------------------------------------+
//|   .               |
//| ( /   ).      |
//|    CStrategy     |
//|  .             |
//|  OnTrade  OnTradeTransaction.                       |
//+------------------------------------------------------------------+
class CTradeEnvironment
  {
private:

   CDictionary       m_pending_orders;
   int               m_last_deals_count;           //    
   int               m_last_pending_orders;        //     
   int               m_last_historders_count;      //     
   bool              m_changed;                    //  ,      
   ulong             m_last_change_time;           //     
   uint              m_last_access;                //      .
   ulong             m_last_microseconds;          //          .
   bool              DetectPendingChanges();
   datetime          StartTimeTerminal(void);
public:
                     CTradeEnvironment(void);
   bool              ChangeEnvironment(void);
   void              RememberEnvironment(void);
   ulong             LastMicrosecondsState(void);
  };
//+------------------------------------------------------------------+
//|  -.                                        |
//+------------------------------------------------------------------+
CTradeEnvironment::CTradeEnvironment(void) : m_changed(true)
  {
  }
//+------------------------------------------------------------------+
//|  ,                |
//+------------------------------------------------------------------+
bool CTradeEnvironment::ChangeEnvironment(void)
  {
   if(m_changed)return true;
   datetime dt=D'2115.01.01';
   HistorySelect(0,dt);
   if(HistoryDealsTotal()!=m_last_deals_count)
     {
      m_changed=true;
     }
   return m_changed;
  }
//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
void CTradeEnvironment::RememberEnvironment(void)
  {
   HistorySelect(0,D'2115.01.01');
   m_last_deals_count=HistoryDealsTotal();
   m_changed=false;
   m_last_microseconds=GetMicrosecondCount();
  }
//+------------------------------------------------------------------+
//|    .                               |
//+------------------------------------------------------------------+
datetime CTradeEnvironment::StartTimeTerminal(void)
  {
   uint start_seconds=(uint)MathRound(GetMicrosecondCount()/1000000.0)+1;
   datetime time_begin=TimeCurrent()-start_seconds;
   return time_begin;
  }
//+------------------------------------------------------------------+
//|              |
//|      .                       |
//+------------------------------------------------------------------+
ulong CTradeEnvironment::LastMicrosecondsState(void)
  {
   return m_last_microseconds;
  }
//+------------------------------------------------------------------+
